/*
 * Copyright (C) 2009-2010 SENJU Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <assert.h>
#include <err.h>
#include <poll.h>
#include <stdio.h>
#include <unistd.h>

#include "lib.h"
#include "sample_sub.h"

int main(int argc, char *argv[])
{
	int err, lsock, sock, port;
	struct sockaddr_in addr;
	char a[BUFSIZ], *p;
	ssize_t ssz;

	/* port = 80; */
	port = IPPORT_USERRESERVED;
	warnx("listening on port %d", port);
	lsock = simple_server_socket(port, 64, /*non-blocking*/0);
	assert(lsock >= 0);

	dummy_init(/*epfd*/-1);
	while (1) {
		socklen_t l = sizeof(addr);
		sock = accept(lsock, (struct sockaddr *)&addr, &l);
		assert(sock >= 0);

		ssz = read(sock, a, sizeof(a));
		assert(ssz > 0);
		assert(ssz != sizeof(a));

		p = get_path(a);
		if (p) {
			dummy_busy(sock, /*do_wait*/1);
			do_sendfile(sock, p);
		}
#if 0
		err = shutdown(sock, SHUT_WR);
		assert(!err);
		sleep(1);
#endif
		err = close(sock);
		assert(!err);
	}

	return 0;
}
